/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.JSHelper.Options;

import java.util.regex.Pattern;

import com.sos.JSHelper.Exceptions.JobSchedulerException;

/**
* \class SOSOptionJdbcUrl 
* 
* \brief SOSOptionJdbcUrl - 
* 
* \details
*
* \section SOSOptionJdbcUrl.java_intro_sec Introduction
*
* \section SOSOptionJdbcUrl.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author oh
* @version $Id$
* \see reference
*
* Created on 28.02.2012 00:58:20
 */
/**
 * @author oh
 *
 */
public class SOSOptionJdbcUrl extends SOSOptionString {
	/**
	 * 
	 */
	private static final long	serialVersionUID	= 299275037361239344L;
	private final String		conClassName	= "SOSOptionJdbcUrl";
	
	/**
	 * \brief SOSOptionJdbcUrl
	 *
	 * \details
	 *
	 * @param pPobjParent
	 * @param pPstrKey
	 * @param pPstrDescription
	 * @param pPstrValue
	 * @param pPstrDefaultValue
	 * @param pPflgIsMandatory
	 */
	public SOSOptionJdbcUrl(JSOptionsClass pPobjParent, String pPstrKey, String pPstrDescription, String pPstrValue, String pPstrDefaultValue,
		boolean pPflgIsMandatory) {
		super(pPobjParent, pPstrKey, pPstrDescription, pPstrValue, pPstrDefaultValue, pPflgIsMandatory);
	}
	
	@Override
	public void Value(final String pstrValue) {
		@SuppressWarnings("unused")
		final String conMethodName = conClassName + "::Value";
		String patternString 	= "jdbc:(mysql|postgresql|oracle:[^:]+|sqlserver|jtds:sqlserver|jtds:sybase|sybase:Tds|firebirdsql|db2):(@|@?//|)?[^:]+(:[0-9]{1,5})?((:|/)[^:;\\?]+)?((\\?|:|;)[^=]+=[^&;]+)?(?:(&|;)[^=]+=[^&;]+)*";
		Pattern pattern 		= Pattern.compile(patternString);
		super.Value(pstrValue);
		if(this.isNotEmpty(this.strValue) && !pattern.matcher(this.strValue).matches()) {
			throw new JobSchedulerException(String.format("invalid syntax in JDBC URL (\"%1$s\").", this.strValue));
        }
	} // private void Value
}
