/********************************************************* begin of preamble
**
** Copyright (C) 2003-2012 Software- und Organisations-Service GmbH. 
** All rights reserved.
**
** This file may be used under the terms of either the 
**
**   GNU General Public License version 2.0 (GPL)
**
**   as published by the Free Software Foundation
**   http://www.gnu.org/licenses/gpl-2.0.txt and appearing in the file
**   LICENSE.GPL included in the packaging of this file. 
**
** or the
**  
**   Agreement for Purchase and Licensing
**
**   as offered by Software- und Organisations-Service GmbH
**   in the respective terms of supply that ship with this file.
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
** IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
** THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
** PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
** BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
** CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
** SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
** INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
** CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
** ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
** POSSIBILITY OF SUCH DAMAGE.
********************************************************** end of preamble*/
package com.sos.scheduler.history;



import com.sos.hibernate.classes.DbItem;
import com.sos.scheduler.history.classes.HistorySeverity;
import com.sos.scheduler.history.db.SchedulerTaskHistoryDBItem;

/**
* \class SchedulerHistoryFilter 
* 
* \brief SchedulerHistoryFilter - 
* 
* \details
*
* \section SchedulerHistoryFilter.java_intro_sec Introduction
*
* \section SchedulerHistoryFilter.java_samples Some Samples
*
* \code
*   .... code goes here ...
* \endcode
*
* <p style="text-align:center">
* <br />---------------------------------------------------------------------------
* <br /> APL/Software GmbH - Berlin
* <br />##### generated by ClaviusXPress (http://www.sos-berlin.com) #########
* <br />---------------------------------------------------------------------------
* </p>
* \author Uwe Risse
* \version 14.12.2011
* \see reference
*
* Created on 14.12.2011 13:53:37
 */

public class SchedulerTaskHistoryFilter extends SchedulerHistoryFilter implements com.sos.hibernate.interfaces.ISOSHibernateFilter {

	@SuppressWarnings("unused")
	private final String	conClassName	= "SchedulerHistoryFilter";
	private String			status			= "";
	protected String		jobname			= null;
 
	 

	protected HistorySeverity	severity	= null;


	public HistorySeverity getSeverity() {
		return severity;
	}

	public void setSeverity(HistorySeverity severity) {
		this.severity = severity;
	}
	public String getJobname() {
		if (jobname == null){
			return jobname;
		}
		
		if (jobname.startsWith("/")) {
			return jobname.substring(1);
		}else {
	    	return jobname;
		}
	}


	public SchedulerTaskHistoryFilter() {
		super();
	}

	public boolean isFiltered(DbItem dbitem) {
			  SchedulerTaskHistoryDBItem h = (SchedulerTaskHistoryDBItem) dbitem;
			  return( this.getIgnoreList().contains(h) || 
					  this.isOnlyJobChains() ||
					  (this.getJobname() != null && this.getJobname().equalsIgnoreCase("(Spooler)")) ||
					  this.isOnlyWithError() && !h.haveError() ||					
                      this.isOnlyRunning() && (h.getEndTime() != null) ||
					  this.getSearchField() != null && !this.getSearchField().equals("") && 		 
					 ((h.getJob() != null && !h.getJob().toLowerCase().contains(this.getSearchField().toLowerCase())))); 
	    
	}
		

	public String getStatus() {
		return status;
	}

	public void setStatus(String status) {
		this.status = status;
	}


	
	public void setJobname(String jobname) {
		this.jobname = jobname;
	}

	public void setSeverity(String severity_) {
		if (this.severity == null) {
			this.severity = new HistorySeverity(severity_);
		}
		else {
			this.severity.setStrValue(severity_);
		}
	}

  
}
